Require MinMJ_psi.
Require MinMJ_MJ.
Require MinMJ_NJ.

Definition m_admis_psi :
	(h:Hyps)(n:N)(R:F)(N_Deduc h n R)-> Prop :=
	 [h:Hyps][n:N][R:F][prf:(N_Deduc h n R)](M_Deriv h (psi n) R).

Definition m_admis_psi' :
	(h:Hyps)(a:A)(P:F)(A_Deduc h a P)->Prop :=
	 [h:Hyps][a:A][P:F][prf:(A_Deduc h a P)]
	  (R:F)(ms:Ms)((Ms_Deriv h P ms R) -> (M_Deriv h (psi' a ms) R)).

Lemma M_admis_psi :
	((h:Hyps)(n:N)(R:F)(prf:(N_Deduc h n R))(m_admis_psi h n R prf))/\
	 ((h:Hyps)(a:A)(R:F)(prf:(A_Deduc h a R))(m_admis_psi' h a R prf)).

Lemma M_Admis_Psi :
	(h:Hyps)(n:N)(R:F)
	 (N_Deduc h n R)->
	  (M_Deriv h (psi n) R).

Lemma M_Admis_Psi' :
	(h:Hyps)(a:A)(ms:Ms)(R:F)(P:F)
	 (A_Deduc h a P)->
	  (Ms_Deriv h P ms R)->
	   (M_Deriv h (psi' a ms) R).

